using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
//There may be an issues about a missing assembly, add the reference: System.Runtime.Remoting via the menu: Project->Add Reference... 
using System.Runtime.Remoting.Channels.Tcp;

namespace RemotingServer
{
    class RemoteingServer{
        
        //Any port number will do, we are going to run it locally
        private static int portNumber = 9999;
       
        //We can't be bothered about security issues so we disable encryption and digital signatures.
        //See more at: http://msdn2.microsoft.com/en-us/library/ms223155.aspx
        private static bool securitySetting = false;
         
        //Name of the service on the server e.g. localhost:port/serviceName
        private static string serviceName = "RemotingServer"; 
        
        static void Main(string[] args)
         {
            Console.WriteLine("Starting Remoting Server - DS-F07");
            
            //We acuire a tcp channel. If you are in firewalled environment this may cause some problems.
            TcpChannel m_TcpChan = new TcpChannel(portNumber);
            
            //Registration with channel services is also required. 
            //See more at: http://msdn2.microsoft.com/en-us/library/system.runtime.remoting.channels.channelservices.aspx
            ChannelServices.RegisterChannel(m_TcpChan, securitySetting);
            
            //This is an example of Server Activated Objects(SAO) meaning that the server conotrls the lifetime of the object.
            //The other possibility is Client Activated Objects, which is not covered futher here.
            //See more at: http://www.c-sharpcorner.com/UploadFile/amit_agrl/DistributedComputing11232005043409AM/DistributedComputing.aspx
            //and for more: http://msdn2.microsoft.com/en-us/library/2fs42683.aspx 
         

            //If RegisterWellKnownServiceType is not called several issues about proxying and instantiation of the  object arise. 
            //See more at: http://msdn2.microsoft.com/en-us/library/czshbka7.aspx
            //The WellKnownService mode allows for objects being exposed on the server end.
            //See more at: http://msdn2.microsoft.com/en-us/library/system.runtime.remoting.wellknownobjectmode.aspx
             RemotingConfiguration.RegisterWellKnownServiceType(
                Type.GetType("RemotingServerObject"), 
              serviceName, WellKnownObjectMode.Singleton); //Note: understand the semantic difference between Singleton and Singlecall. For the Singleton mode the are issues of thread usage, life time leases and multiple clients data sharing. 
            System.Console.WriteLine("Press ENTER to quit");
            System.Console.ReadLine();
            System.Console.WriteLine("So long and thanks for all the fish");
        }
    }

}
